/*
 * DFPLAYER_MINI.c
 *
 *  Created on: January 14, 2023
 *  Author:  JM_PALOMINO
 *  Based on :  controllerstech library 
 */

#include "DFPLAYER_MINI.h"

void Send_cmd (char cmd, char Parameter1, char Parameter2)
{
        unsigned int Checksum = 0;
        char  CmdSequence[10];
        unsigned short i = 0;
         
        Checksum = Version + Cmd_Len + cmd + Feedback + Parameter1 + Parameter2;
        Checksum = 0-Checksum ;
        CmdSequence[0] = Start_Byte;
        CmdSequence[1] = Version;
        CmdSequence[2] = Cmd_Len;
        CmdSequence[3] = Cmd;
        CmdSequence[4] = Feedback;
        CmdSequence[5] = Parameter1;
        CmdSequence[6] = Parameter2;
        CmdSequence[7] = (Checksum>>8)&0x00ff;
        CmdSequence[8] = (Checksum&0x00ff);
        CmdSequence[9] =  End_Byte;
        
         for(i=0; i<10; i++){
          UART1_Write( CmdSequence[i]);
     }
}

void DF_PlayFromStart(void)
{
  Send_cmd(0x03,0x00,0x01);
  Delay_ms(200);
}


void DF_Init (char volume)
{
        Send_cmd(0x3F, 0x00, Source);
        Delay_ms(200);
        Send_cmd(0x06, 0x00, volume);
        Delay_ms(500);
}


void DF_Next (void)
{
        Send_cmd(next, 0x00, 0x00);
        Delay_ms(200);
}

void DF_Pause (void)
{
        Send_cmd(pause , 0, 0);
        Delay_ms(200);
}

void DF_Previous (void)
{
        Send_cmd(previus, 0, 0);
       Delay_ms(200);
}

void DF_Playback (void)
{
        Send_cmd(play, 0, 0);
        Delay_ms(200);
}

void DF_Randon(void)
{
        Send_cmd(randon , 0, 0);
        Delay_ms(200);
}

void DF_Track (unsigned int pista)
{
        Send_cmd(track, 0x00, pista);
       Delay_ms(200);
}