#include "tm1637_lib.h"
#include "DFPLAYER_MINI.h"
#include "built_in.h"

short int e0=1, e1=1, e2=1, play_pause=0, aux =0;
unsigned int trk=1;

void set_up() {

  INTCON = 0;          // Todas las interrupciones deshabilitadas
  ANSEL = 0;       // Pin RA2 se configura como una entrada analgica
  ANSELH = 0;        // Los dems pines se configuran como digitales
  TRISB6_bit=0;     // los pies B6 y B7 se configuran como salidas
  TRISB7_bit=0;
  TRISC7_bit=1;
  TRISC6_bit=0;
  TRISD0_bit=1;
  TRISD1_bit=1;
  TRISD2_bit=1;
  TRISD3_bit=1;
  RB7_bit=0;  //CLK
  RB6_bit=0; // DATA
  C1ON_bit = 0;    // se desactivan los comparadores analgicos
  C2ON_bit = 0;
  CCP1CON = 0;   //PWM1 y PWM2 desactivados.
  CCP2CON = 0;
  UART1_Init(9600);
  Delay_ms(100);
  DF_Init(12);
  DF_PlayFromStart();
  DF_Track (trk);
  Delay_ms(200);
}

void main() {

    set_up();
    TM1637_SetBrightness(7);
    TM1637_Init();
    TM1637_DisplayDecimal(trk, 0);
    DF_Track (trk);
    Delay_ms(20);
    
   do {
    if ((play_pause == 1) && (aux==0)) DF_Pause(), aux=1;
    if ((play_pause >= 2) && (aux==1)) DF_Playback(), play_pause=0, aux=0;
    
    if (Button(&PORTD,3,10,1) && (play_pause == 0)) {
          trk++;
          if(trk > 12)  trk = 1;
          TM1637_DisplayDecimal(trk, 0);
          DF_Track (trk);
          Delay_ms(20);
        }
   
    if (Button(&PORTD,0,10,0)) e0=0;     //if the button has been pushed
    if (e0==0 && Button(&PORTD,0,10,1)){ //and after that the button is free
        trk++;                         //increase select.
      if (trk>12) trk=1;
      TM1637_DisplayDecimal(trk, 0); // 0: OFF 1: ON
      DF_Track (trk);
      Delay_ms(20);
      e0=1;
   }
   
    if (Button(&PORTD,1,10,0)) e1=0;     //if the button has been pushed
    if (e1==0 && Button(&PORTD,1,10,1)){ //and after that the button is free
        trk--;                         //decrease select.
      if (trk<1) trk=12;
      TM1637_DisplayDecimal(trk, 0); // 0: OFF 1: ON
      DF_Track (trk);
      Delay_ms(20);
      e1=1;
   }
   
    if (Button(&PORTD,2,10,0)) e2=0;     //if the button has been pushed
    if (e2==0 && Button(&PORTD,2,10,1)){ //and after that the button is free
      play_pause++;
      Delay_ms(20);
      e2=1;
   }

  } while (1);
}